%# DEMO
i = 0 ; j=0; 
x=[]; Xa = []; Xb=[];  D=[] ; X=[]; Y=[] ;  Z1=[];Z2=[];Z3=[];DD=[];

%				# first define a centre and crcle of interest
i = 0; radius = 0.1 ; c=[]; m=[0.5,0.5] ;
ym = displace(m) ; 
for t=7.5:15:360
  i=i+1;
  th = t /( 180/3.141592 ); 
  c(i,:)=m+[cos(th),sin(th)]*radius;
  i=i+1;
  c(i,:)=m;
end

i = 0 ; j = 0 ; 
%# now make a grid and keep track of distance from the centre
for xa = 0:0.05:1
  j = j + 1 ; 
  k=0 ;
  Xa(j) = xa ;
  for xb = 0:0.05:1
    
    k = k + 1 ; 
    i = i + 1 ; 
    x(i,:)  = [xa,xb] ;
    X(j,k) = xa; Y(j,k) = xb ; 
    Z1(j,k) = -10.0 ; 
    Z2(j,k) = -2.0 ; 
    Z3(j,k) = -3.0 ;
    dist = [xa,xb] - m ;
    dista = displace([xa,xb]) - ym ;
    D(j,k) = dist * dist' ; %# distance before
    Dafter(j,k) = dista * dista' ; %# distance after
    DD(j,k) = Dafter(j,k) - D(j,k) ; %# distance change
    if ( j == 1 )
      Xb(k) = xb ; 
    end
  end
end

y = displace(x);
cy = displace(c);
[M,N] = size(X) ; 
Xp = reshape( y(:,1) , M,N ) ;
Yp = reshape( y(:,2) , M,N ) ;

figure(1) ;
hold off ;
axis square ;
axis([0 2 0 2]);
view([0,90]) ; 
mesh( X, Y , Z1 ) ;
view([0,90]) ;
hold on ;
plot(c(:,1),c(:,2)) ; 
mesh( Xp, Yp , Z2 ) ;
view([0,90]) ; 
axis square ;
hold on ;
plot(cy(:,1),cy(:,2)) ; 

disp 'ready?'

pause

figure(2);

hold off
meshc( X, Y , DD ) ;
[cc,hh] =  contour( X, Y , DD ) ; clabel(cc,hh), colorbar



%%%%%%%%%%%%%%% do it again



% pause
disp 'computing finer grid'

%# DEMO
i = 0 ; j=0; 
x=[]; Xa = []; Xb=[];  D=[] ;  X=[]; Y=[] ;  Z1=[];Z2=[];Z3=[];DD=[];

%# now make a grid and keep track of distance from the centre
for xa = 0.4:0.003:0.6
  j = j + 1 ; 
  k=0 ;
  Xa(j) = xa ;
  for xb = 0.4:0.003:0.6
    
    k = k + 1 ; 
    i = i + 1 ; 
    x(i,:)  = [xa,xb] ;
    X(j,k) = xa; Y(j,k) = xb ; 
    Z1(j,k) = -10.0 ; 
    Z2(j,k) = -2.0 ; 
    Z3(j,k) = -3.0 ;
    dist = [xa,xb] - m ;
    dista = displace([xa,xb]) - ym ;
    D(j,k) = dist * dist' ; %# distance before
    Dafter(j,k) = dista * dista' ; %# distance after
    DD(j,k) = Dafter(j,k) - D(j,k) ; %# distance change
    if ( j == 1 )
      Xb(k) = xb ; 
    end
  end
end


 disp 'ready to show it'
 pause
 disp 'ok, here it is'

figure(2);

hold off
axis([0.4 0.6 0.4 0.6])
meshc( X, Y , DD ) ;
[cc,hh] =  contour( X, Y , DD ) ; clabel(cc,hh), colorbar


pause ; 




%%%%%%%%%%%%%%%% now pick a new point of interest

i = 0; radius = 0.1 ; c=[]; m=[0.9,0.1] ;
ym = displace(m) ; 
for t=7.5:15:360
  i=i+1;
  th = t /( 180/3.141592 ); 
  c(i,:)=m+[cos(th),sin(th)]*radius;
  i=i+1;
  c(i,:)=m;
end


x=[]; Xa = []; Xb=[];  D=[] ;  X=[]; Y=[] ; Z1=[];Z2=[];Z3=[];DD=[];
%# now make a grid and keep track of distance from the centre
i=0;j=0;
for xa = 0.8:0.01:1.0
  j = j + 1 ; 
  k=0 ;
  Xa(j) = xa ;
  for xb = 0:0.01:0.2
    
    k = k + 1 ; 
    i = i + 1 ; 
    x(i,:)  = [xa,xb] ;
    X(j,k) = xa; Y(j,k) = xb ; 
    Z1(j,k) = -10.0 ; 
    Z2(j,k) = -2.0 ; 
    Z3(j,k) = -3.0 ;
    dist = [xa,xb] - m ;
    dista = displace([xa,xb]) - ym ;
    D(j,k) = dist * dist' ; %# distance before
    Dafter(j,k) = dista * dista' ; %# distance after
    DD(j,k) = Dafter(j,k) - D(j,k) ; %# distance change
    if ( j == 1 )
      Xb(k) = xb ; 
    end
  end
end

cy=displace(c);
figure(1) ; 
hold on ;
plot(c(:,1),c(:,2)) ; 
hold on ;
plot(cy(:,1),cy(:,2)) ; 

disp 'ready to show next grid'
 pause
 disp 'ok, here it is'

figure(2);

hold off
axis([0.8 1.0 0.8 1])
meshc( X, Y , DD ) ;
[cc,hh] =  contour( X, Y , DD ) ; clabel(cc,hh), colorbar




