%# DEMO
for option = 1:6 ; 
  i = 0 ; j=0; 
  x=[]; Xa = []; Xb=[];  D=[] ; X=[]; Y=[] ;  Z1=[];Z2=[];Z3=[];DD=[];
  
  %				# first define a centre and crcle of interest
  i = 0; radius = 0.3 ; c=[]; m=[0.5,0.5] ;
  ym = displace(m,option) ;
  dt = 90/6 ; 
  for t=0:2*dt:360
    i=i+1;
    th = t /( 180/3.141592 ); 
    c(i,:)=m+[cos(th),sin(th)]*radius;
    i=i+1;
    c(i,:)=m;
  end

  i = 0 ; j = 0 ; 
  %# now make a grid and keep track of distance from the centre
  steps = 15 ; 
  step = 1.0/steps ; 
  for xa = 0:step:1
    j = j + 1 ; 
    k=0 ;
    Xa(j) = xa ;
    for xb = 0:step:1
      
      k = k + 1 ; 
      i = i + 1 ; 
      x(i,:)  = [xa,xb] ;
      X(j,k) = xa; Y(j,k) = xb ; 
      Z1(j,k) = -2*i-3*steps*steps ;       Z2(j,k) = -i ;     
      dist = [xa,xb] - m ;
      dista = displace([xa,xb],option) - ym ;
      D(j,k) = dist * dist' ; %# distance before
      Dafter(j,k) = dista * dista' ; %# distance after
      DD(j,k) = Dafter(j,k) - D(j,k) ; %# distance change
      if ( j == 1 )
	Xb(k) = xb ; 
      end
    end
  end
  
  y = displace(x,option);
  cy = displace(c,option);
  [M,N] = size(X) ; 
  Xp = reshape( y(:,1) , M,N ) ;
  Yp = reshape( y(:,2) , M,N ) ;
  
  figure(1) ;
  hold off ;
  view([0,90]) ; 
  mesh( X, Y , Z1 ) ; % # original
  axis square ;  axis([0 2 0 2]);
  hold on ;
  if (option>1)
    plot(c(:,1),c(:,2),'r-') ;
  end
  mesh( Xp, Yp , Z2 ) ; % # deformed
  view([0,90]) ; 
  axis square ;
  hold on ;
  if (option>1)
    plot(cy(:,1),cy(:,2),'b-') ; 
  end
  disp 'ready?'
  
  if (option>1)
  
    figure(2);
    
    hold off
    v=(-1.005:0.01:1); %# vector of heights
%#    meshc( X, Y , DD ) ;
%    [cc,hh] =  contour( X, Y , DD ,15 ) ; clabel(cc,hh), colorbar
[cc,hh] =  contour( X, Y , DD ,v ) ; shading interp ; colorbar
  end
  
  disp 'ready for next option?'
  
  pause
  
  
end




